/*
 * Copyright (C) 2013 Snowsun <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AbstractAppState;
import com.jme3.app.state.AppStateManager;
import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.wyrez.shootingstars.data.YTDownloader;
import org.wyrez.shootingstars.game.GameSettings;
import org.wyrez.shootingstars.gui.YTDownloadGUI;
import org.wyrez.shootingstars.gui.listener.YTDownloadListener;
import org.wyrez.shootingstars.helper.PathHelper;
import tonegod.gui.core.Screen;

/**
 *
 * @author Snowsun
 */
public class YTDownloadState extends AbstractAppState implements YTDownloadListener {

    private static final Pattern YT_LINK_PATTERN = Pattern.compile("\\?v=[^\\&]*\\&??");
    /**/
    private StateManager stateManager;
    private GameSettings settings;
    private YTDownloadGUI gui;
    private YTDownloader downloader;

    public YTDownloadState(Screen screen, StateManager stateManager,
            GameSettings settings, YTDownloader downloader) {
        this.stateManager = stateManager;
        this.settings = settings;
        this.gui = new YTDownloadGUI(screen, this);
        this.downloader = downloader;
    }

    @Override
    public void stateAttached(AppStateManager stateManager) {
        gui.attach();
    }

    @Override
    public void stateDetached(AppStateManager stateManager) {
        gui.detach();
    }

    public void downloadYTVideo(String url) {
        try {
            Matcher matcher = YT_LINK_PATTERN.matcher(url);
            String identifier = "";
            if (matcher.find()) {
                identifier = matcher.group().replace("?v=", "");
            } else {
                //TODO add error message
                stateManager.setState(State.MENU);
            }
            String path;
            if ((path = getVideoCache(identifier)) == null) {
                downloader.download(url, PathHelper.getCacheFolder());
                path = downloader.getLastTarget().getPath();
                new File(path).renameTo(new File(PathHelper.getCacheFolder()
                        + identifier + path.substring(path.lastIndexOf("."), path.length())));
                System.out.println("rename " + path + " --> " + (PathHelper.getCacheFolder()
                        + identifier + path.substring(path.lastIndexOf("."), path.length())));
            }
            settings.setVideoFile(path);
            stateManager.setState(State.FILEMETAINFO);
        } catch (Exception ex) {
            stateManager.setState(State.MENU);
        }
    }

    private String getVideoCache(String identifier) {
        File[] cachedFiles = new File(PathHelper.getCacheFolder()).listFiles();
        for (File file : cachedFiles) {
            if (file.getName().substring(0, file.getName().lastIndexOf(".")).equals(identifier)) {
                return file.getPath();
            }
        }
        return null;
    }
}
